/*
 * Copyright (c) 2024, Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * 'Software'), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

////////////////////////////////////////////////////////////////////////////////
// !!! WARNING - AUTO GENERATED FILE. DO NOT EDIT DIRECTLY. !!!
// Generated by KernelBinToSource.exe tool
////////////////////////////////////////////////////////////////////////////////

#if !defined(MEDIA_BIN_DLL)
#include "vp_platform_interface.h"
#include "vp_render_common.h"
#endif
#include "igvpfc_420PL3_input_xe2.h"

#if defined(MEDIA_BIN_SUPPORT) && !defined(MEDIA_BIN_DLL)

unsigned int IGVPFC_420PL3_INPUT_GENERATION_XE2_SIZE = 0;
unsigned int *IGVPFC_420PL3_INPUT_GENERATION_XE2 = nullptr;
static bool getIGVPFC_420PL3_INPUT_XE2 = LoadMediaBin(IGVPFC_420PL3_INPUT_GENERATION_XE2_NAME, &IGVPFC_420PL3_INPUT_GENERATION_XE2_SIZE, &IGVPFC_420PL3_INPUT_GENERATION_XE2);

#endif  // defined(MEDIA_BIN_SUPPORT) && !defined(MEDIA_BIN_DLL)

#if !defined(MEDIA_BIN_DLL)
void AddVpNativeKernelEntryToListFc_420pl3_inputXe2(vp::VpPlatformInterface &vpPlatformInterface)
{
    vp::KRN_ARG IMAGEREAD_CURBE[] =
    {
        {FC_420PL3_INPUT_IMAGEREAD_WIDTH, 0, 0, 4, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_HEIGHT, 4, 0, 4, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_LUMAINDEX, 8, 0, 4, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_CHROMAINDEXS, 16, 0, 16, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_PRIVATE_BASE_STATELESS, 32, 0, 8, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_ENQUEUED_LOCAL_SIZE, 40, 0, 12, vp::ARG_KIND_GENERAL, false, vp::AddressingModeStateful},
        {FC_420PL3_INPUT_IMAGEREAD_GLOBAL_ID_OFFSET, 0, 0, 12, vp::ARG_KIND_INLINE},
        {FC_420PL3_INPUT_IMAGEREAD_LOCAL_SIZE, 12, 0, 12, vp::ARG_KIND_INLINE},
    };

    vp::KRN_EXECUTE_ENV IMAGEREAD_PARAM =
    {
        0,         //barrier_count
        true,      //disable_mid_thread_preemption
        128,       //grf_count
        false,     //has_global_atomics
        true,      //has_no_stateless_write
        32,        //inline_data_payload_size
        192,       //offset_to_skip_per_thread_data_load
        32,        //simd_size
        true,      //subgroup_independent_forward_progress
        8,         //eu_thread_count
        false,     //has_fence_for_image_access
        false,     //has_sample
        true,      //has_4gb_buffers
        { 0, 0, 0 },         //work_group_walk_order_dimensions
        0,         //private_size
        0         //slm_size
    };

    vp::KRN_BTI IMAGEREAD_BTI[] =
    {
        {FC_420PL3_INPUT_IMAGEREAD_INPUT0PLY, 0},
        {FC_420PL3_INPUT_IMAGEREAD_INPUT0PL1, 1},
        {FC_420PL3_INPUT_IMAGEREAD_INPUT0PL2, 2},
        {FC_420PL3_INPUT_IMAGEREAD_OUTPUTPLY, 3},
        {FC_420PL3_INPUT_IMAGEREAD_OUTPUTPLUV, 4},
    };

    vpPlatformInterface.InitVpDelayedNativeAdvKernel((uint32_t *)((uint8_t *)IGVPFC_420PL3_INPUT_GENERATION_XE2 + 0), 3328, IMAGEREAD_CURBE, 8, 52, IMAGEREAD_PARAM, IMAGEREAD_BTI, 5, "ImageRead_fc_420PL3_input");

}
#endif

#if !defined(MEDIA_BIN_SUPPORT) || defined(MEDIA_BIN_DLL)
DEFINE_SHARED_ARRAY_SIZE_UINT32(IGVPFC_420PL3_INPUT_GENERATION_XE2_SIZE, 3328);
extern const unsigned int IGVPFC_420PL3_INPUT_GENERATION_XE2[] =
{
    0x80100061, 0x7f054220, 0x00000000, 0x00000000, 0x80000065, 0x7f258220, 0x02000004, 0xffffffc0, 
    0x80000065, 0x7f058110, 0x01000024, 0x00ff00ff, 0x80001a40, 0x7f258220, 0x02007f24, 0x00000040, 
    0x80001940, 0x7f258220, 0x02007f24, 0x00000000, 0x8000195b, 0x7f048220, 0x01017f24, 0x00c07f04, 
    0x800c0061, 0x04050220, 0x00100104, 0x00000000, 0x80012031, 0x01140000, 0xfa007f8f, 0xf6780003, 
    0x8000c131, 0x030c0800, 0xfa007f8f, 0xf6740003, 0x00000060, 0x00000000, 0x00000000, 0x00000000, 
    0x00000060, 0x00000000, 0x00000000, 0x00000000, 0x00000060, 0x00000000, 0x00000000, 0x00000000, 
    0x3c8ca101, 0x00100000, 0x8000a065, 0x7f058220, 0x02000004, 0xffffffc0, 0x80001940, 0x7f058220, 
    0x02007f04, 0x00000000, 0x80032231, 0x050c0000, 0xfa007f8f, 0xf6740003, 0x2c240061, 0x00100065, 
    0x80000966, 0x80018220, 0x02008000, 0x400004c0, 0x80032241, 0x20010660, 0x010005a4, 0x00006514, 
    0xac848153, 0x65470503, 0x80000041, 0x20010660, 0x010005b4, 0x00006564, 0xac840053, 0x65fe0506, 
    0x00156052, 0x66040660, 0x010e0304, 0x04040104, 0x00141a52, 0x68040660, 0x010e0604, 0x04140204, 
    0x00172331, 0x08440000, 0x20006614, 0x01686814, 0x28200061, 0x00106639, 0x28200061, 0x0010683b, 
    0x00148365, 0x10058660, 0x06100804, 0x807fffff, 0x00140065, 0x12058660, 0x06100a04, 0x807fffff, 
    0x00541a70, 0x21050660, 0x16101004, 0x00100804, 0x00140065, 0x14058660, 0x06100c04, 0x807fffff, 
    0x00141b70, 0x25050660, 0x16101204, 0x00100a04, 0x00140065, 0x19058660, 0x06100804, 0x80000000, 
    0x80140070, 0x00018660, 0x15000524, 0x00000000, 0x00140065, 0x16058660, 0x06100e04, 0x807fffff, 
    0x00d41d70, 0x29050660, 0x16101404, 0x00100c04, 0x00140065, 0x1b058660, 0x06100a04, 0x80000000, 
    0x00141d6b, 0x23040228, 0xd28a2104, 0x08051904, 0x80d40070, 0x00018660, 0x15000524, 0x00010001, 
    0x00941d70, 0x2d050660, 0x16101604, 0x00100e04, 0x00140065, 0x1d058660, 0x06100c04, 0x80000000, 
    0x00141d6b, 0x27040228, 0xd28a2504, 0x0a051b04, 0x04141d62, 0x20018aa0, 0x0a102304, 0x00000000, 
    0x80941170, 0x00018660, 0x15000524, 0x00020002, 0x00140065, 0x1f058660, 0x06100e04, 0x80000000, 
    0x80540070, 0x00018660, 0x15000524, 0x00030003, 0x00141d6b, 0x2b040228, 0xd28a2904, 0x0c051d04, 
    0x04d41d62, 0x20010aa0, 0x0a102704, 0x00102000, 0x00141b6b, 0x2f040228, 0xd28a2d04, 0x0e051f04, 
    0x04941a62, 0x20010aa0, 0x0a102b04, 0x00102000, 0x04541962, 0x20010aa0, 0x0a102f04, 0x00102000, 
    0x00140061, 0x31050aa0, 0x00102000, 0x00000000, 0x00140061, 0x33050aa0, 0x00102000, 0x00000000, 
    0x00140061, 0x35050aa0, 0x00102000, 0x00000000, 0x00140061, 0x37050aa0, 0x00102000, 0x00000000, 
    0x80141570, 0x00018660, 0x55000504, 0x00000000, 0x00162431, 0x00000000, 0xda0c39a7, 0x043c3144, 
    0x94000020, 0x00004000, 0x00000000, 0x00000018, 0x68840040, 0x00100505, 0x80d40070, 0x00018660, 
    0x55000514, 0x00000000, 0x80001a6c, 0x05358660, 0x05000504, 0x00010001, 0x94c00020, 0x00004000, 
    0x00000000, 0x00000020, 0x80000040, 0x05158660, 0x05000514, 0x00010001, 0x6884196c, 0x00110501, 
    0x00541970, 0x00010660, 0x56106804, 0x00000104, 0x04540070, 0x00010660, 0x56106604, 0x00000534, 
    0x1454002e, 0x0000c000, 0x00000870, 0x00000870, 0x68840065, 0x00740516, 0x80000065, 0x17058660, 
    0x05000554, 0x00070007, 0x80d41a70, 0x00018660, 0x15001604, 0x00010001, 0xec840061, 0x00103321, 
    0x80d40070, 0x00018660, 0x15001604, 0x00020002, 0xec840061, 0x00103324, 0x80d40070, 0x00018660, 
    0x15001604, 0x00030003, 0xec840061, 0x00103327, 0x80d41f70, 0x00018660, 0x15001704, 0x00030003, 
    0x68840065, 0x007c0518, 0xec840061, 0x00103328, 0x80d41a70, 0x00018660, 0x15001804, 0x00030003, 
    0x80000065, 0x19058660, 0x05000574, 0x00070007, 0xec840061, 0x00103329, 0x80d41a70, 0x00018660, 
    0x15001904, 0x00030003, 0xec840061, 0x0010332a, 0x80d40070, 0x00018660, 0x15001604, 0x00040004, 
    0xec840061, 0x0010332b, 0x80d40070, 0x00018660, 0x15001704, 0x00040004, 0xec840061, 0x0010332c, 
    0x80d40070, 0x00018660, 0x15001804, 0x00040004, 0x0014c531, 0x06440000, 0x20026614, 0x01686814, 
    0xec840061, 0x0010332d, 0x80d40070, 0x00018660, 0x15001904, 0x00040004, 0xec840061, 0x0010332e, 
    0x80d40070, 0x00018660, 0x15001604, 0x00050005, 0xec840061, 0x0010332f, 0x80d40070, 0x00018660, 
    0x15001704, 0x00050005, 0xec840061, 0x00103330, 0x80d40070, 0x00018660, 0x15001804, 0x00050005, 
    0xec84a461, 0x00103331, 0x80d40070, 0x00018660, 0x15001904, 0x00050005, 0xec840061, 0x00103332, 
    0x80d40070, 0x00018660, 0x15001604, 0x00060006, 0xec840061, 0x00103333, 0x80d40070, 0x00018660, 
    0x15001704, 0x00060006, 0xec840061, 0x00103334, 0x80d40070, 0x00018660, 0x15001804, 0x00060006, 
    0xec840061, 0x00103335, 0x80d40070, 0x00018660, 0x15001904, 0x00060006, 0xec840061, 0x00103336, 
    0x80d40070, 0x00018660, 0x15001604, 0x00070007, 0x0014c631, 0x0e440000, 0x20046614, 0x01686814, 
    0xec840061, 0x00103337, 0x80d40070, 0x00018660, 0x15001704, 0x00070007, 0xec840061, 0x00103338, 
    0x80d40070, 0x00018660, 0x15001804, 0x00070007, 0xec840061, 0x00103339, 0x80d40070, 0x00018660, 
    0x15001904, 0x00070007, 0x00148565, 0x3b058660, 0x06100604, 0x807fffff, 0xec840061, 0x0010333a, 
    0x00d41a70, 0x62050660, 0x16103b04, 0x00100604, 0x00140065, 0x3d058660, 0x06100804, 0x807fffff, 
    0xec840061, 0x00103364, 0x00d41a70, 0x6a050660, 0x16103d04, 0x00100804, 0x00140065, 0x41058660, 
    0x06100a04, 0x807fffff, 0xec840061, 0x0010336c, 0x00d41a70, 0x6e050660, 0x16104104, 0x00100a04, 
    0x80940070, 0x00018660, 0x15001604, 0x00000000, 0x00140065, 0x49058660, 0x06100c04, 0x807fffff, 
    0xec840061, 0x00103370, 0x00d41a70, 0x72050660, 0x16104904, 0x00100c04, 0xec840061, 0x0010321e, 
    0x80540070, 0x00018660, 0x15001704, 0x00000000, 0x00140065, 0x3f058660, 0x06100604, 0x80000000, 
    0xec840061, 0x00103374, 0xfc841c61, 0x00101e33, 0x00141b6b, 0x75040228, 0xd28a6204, 0x06053f04, 
    0xec840061, 0x0010311f, 0x80140070, 0x00018660, 0x15001804, 0x00000000, 0x04d41b62, 0x20018aa0, 
    0x0a107504, 0x00000000, 0xfc840961, 0x00101f33, 0xec840061, 0x00103020, 0x80140070, 0x00018660, 
    0x15001804, 0x00010001, 0x04d40062, 0x22018aa0, 0x0a107504, 0x00000000, 0xfc840961, 0x00102033, 
    0x80540070, 0x00018660, 0x15001704, 0x00010001, 0x80940070, 0x00018660, 0x15001904, 0x00000000, 
    0xec840061, 0x00103023, 0x04d40062, 0x03058aa0, 0x0a107504, 0x00000000, 0x80141170, 0x00018660, 
    0x15001704, 0x00020002, 0x00140065, 0x47058660, 0x06100804, 0x80000000, 0xfc840061, 0x00102133, 
    0xec840061, 0x00103122, 0x04941c62, 0x16058aa0, 0x0a107504, 0x00000000, 0x00141b6b, 0x77040228, 
    0xd28a6a04, 0x08054704, 0xec840061, 0x00103025, 0xfc840961, 0x00102232, 0x80140070, 0x00018660, 
    0x15001804, 0x00020002, 0x04d41c62, 0x20010aa0, 0x0a107704, 0x00102000, 0x80541170, 0x00018660, 
    0x15001904, 0x00010001, 0xfc840061, 0x00102333, 0x00140065, 0x4b058660, 0x06100a04, 0x80000000, 
    0xec840061, 0x00103026, 0x04940062, 0x22010aa0, 0x0a107704, 0x00102200, 0x80141170, 0x00018660, 
    0x15001904, 0x00020002, 0xfc840061, 0x00102432, 0x04540062, 0x1e050aa0, 0x0a107704, 0x00101604, 
    0x00141c6b, 0x01040228, 0xd28a6e04, 0x0a054b04, 0x04d41b62, 0x18050aa0, 0x0a107704, 0x00100304, 
    0x00148665, 0x51058660, 0x06101004, 0x807fffff, 0xfc841161, 0x00102531, 0xfc840061, 0x00102633, 
    0x04141c62, 0x22050aa0, 0x0a100104, 0x00101e04, 0x04940062, 0x20010aa0, 0x0a100104, 0x00102000, 
    0x00140970, 0x3d050660, 0x16105104, 0x00101004, 0x00140065, 0x4f058660, 0x06100c04, 0x80000000, 
    0x00140065, 0x4d058660, 0x06100e04, 0x807fffff, 0xfc840061, 0x00102730, 0x04d40062, 0x20050aa0, 
    0x0a100104, 0x00101804, 0x04540062, 0x22010aa0, 0x0a100104, 0x00102200, 0xfc841161, 0x00102932, 
    0x00141c6b, 0x24040228, 0xd28a7204, 0x0c054f04, 0xfc840061, 0x00102833, 0x00541d70, 0x3b050660, 
    0x16104d04, 0x00100e04, 0xfc840061, 0x00102a31, 0x04141c62, 0x20010aa0, 0x0a102404, 0x00102000, 
    0x00140065, 0x55058660, 0x06101204, 0x807fffff, 0x00140065, 0x53058660, 0x06100e04, 0x80000000, 
    0x04940062, 0x3f050aa0, 0x0a102404, 0x00102004, 0x04d40062, 0x22010aa0, 0x0a102404, 0x00102200, 
    0xfc841161, 0x00102b30, 0x04540062, 0x41050aa0, 0x0a102404, 0x00102204, 0xfc841161, 0x00102d32, 
    0x00d41c70, 0x47050660, 0x16105504, 0x00101204, 0x00141c6b, 0x43040228, 0xd28a3b04, 0x0e055304, 
    0xfc840061, 0x00102e31, 0xfc840061, 0x00102c33, 0x04141b62, 0x20010aa0, 0x0a104304, 0x00102000, 
    0x00140065, 0x57058660, 0x06101004, 0x80000000, 0x04940062, 0x49050aa0, 0x0a104304, 0x00103f04, 
    0xfc841161, 0x00102f30, 0x04540062, 0x4b050aa0, 0x0a104304, 0x00104104, 0x04d40062, 0x22010aa0, 
    0x0a104304, 0x00102200, 0xfc841161, 0x00103132, 0x00141b6b, 0x45040228, 0xd28a3d04, 0x10055704, 
    0xfc840061, 0x00103231, 0xfc840061, 0x00103033, 0x00140065, 0x59058660, 0x06101404, 0x807fffff, 
    0x04141c62, 0x20010aa0, 0x0a104504, 0x00102000, 0x00140065, 0x5b058660, 0x06101204, 0x80000000, 
    0x04940062, 0x4d050aa0, 0x0a104504, 0x00104904, 0xfc841161, 0x00103330, 0x04540062, 0x4f050aa0, 
    0x0a104504, 0x00104b04, 0x04d40062, 0x22010aa0, 0x0a104504, 0x00102200, 0x00940970, 0x53050660, 
    0x16105904, 0x00101404, 0x00141b6b, 0x51040228, 0xd28a4704, 0x12055b04, 0xfc840061, 0x00103631, 
    0xfc840061, 0x00103433, 0xfc840061, 0x00103532, 0x04141c62, 0x20010aa0, 0x0a105104, 0x00102000, 
    0x04540062, 0x57050aa0, 0x0a105104, 0x00104f04, 0x04940062, 0x55050aa0, 0x0a105104, 0x00104d04, 
    0x04d40062, 0x22010aa0, 0x0a105104, 0x00102200, 0x00140065, 0x5d058660, 0x06101404, 0x80000000, 
    0xfc841161, 0x00103730, 0xfc840061, 0x00103a31, 0xfc840061, 0x00103932, 0xfc840061, 0x00103833, 
    0x00141d6b, 0x59040228, 0xd28a5304, 0x14055d04, 0x28200061, 0x0010661a, 0x28200061, 0x0010681c, 
    0x04141962, 0x5b050aa0, 0x0a105904, 0x00102000, 0x04d40062, 0x5d050aa0, 0x0a105904, 0x00102200, 
    0x04940062, 0x5f050aa0, 0x0a105904, 0x00105504, 0x04540062, 0x61050aa0, 0x0a105904, 0x00105704, 
    0x00162731, 0x00000000, 0xda0c1aa4, 0x043c5b45, 0x0014002f, 0x00004000, 0x00000000, 0x00000010, 
    0x28100061, 0x0010657f, 0x80022031, 0x00000004, 0x30207f0c, 0x00000000, 0x00000000, 0x00000000, 
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
    0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000
};
#endif // !defined(MEDIA_BIN_SUPPORT) || defined(MEDIA_BIN_DLL)